const { Client, MessageEmbed } = require('discord.js');

class Message extends Client {
  constructor(client) {
    super(client);
    this.client = client;
  }

  createMessage(mesaj, kanal) {
    if (!mesaj) return console.log('Bot boş mesaj gönderemez.');
    if (!kanal) return console.log('Bot tanımlayan kanala mesaj gönderemez.');
    return kanal.send(mesaj);
  }

  deleteMessage(mesaj, kanal) {
    if (!mesaj) return console.log('Bot boş mesajı silemez.');
    if (!kanal) return console.log('Bot tanımlayan kanaldaki mesajı silemez.');
    return kanal.messages.cache.get(mesaj).delete();
  }

  editMessage(mesaj, mesajId, kanal) {
    if (!mesaj) return console.log('Bot boş mesajı düzenleyemez.');
    if (!kanal) return console.log('Bot tanımlayan kanaldaki mesajı düzenleyemez.');
    if (!mesajId) return console.log('Bot mesajı boş olarak düzenleyemez.');
    return kanal.messages.cache.get(mesajId).edit(mesaj);
  }

  createEmbedMessage({ title, authorLabel, authorIcon, footerLabel, footerIcon, description, image, thumbnail, color, url }, channel) {
    if (!title) {
      var EmbedCreator = new MessageEmbed()
      .setAuthor(authorLabel, authorIcon)
      .setFooter(footerLabel, footerIcon)
      .setColor(color || "BLACK")
      .setDescription(description)
      .setURL(url)
      .setImage(image)
      .setThumbnail(thumbnail)
      return channel.send({ embed: EmbedCreator });
    } else if (!authorLabel && !authorIcon) {
      var EmbedCreator = new MessageEmbed()
      .setTitle(title)
      .setFooter(footerLabel, footerIcon)
      .setColor(color || "BLACK")
      .setDescription(description)
      .setURL(url)
      .setImage(image)
      .setThumbnail(thumbnail)
      return channel.send({ embed: EmbedCreator });
    } else if (!footerLabel && !footerIcon) {
      var EmbedCreator = new MessageEmbed()
      .setAuthor(authorLabel, authorIcon)
      .setTitle(title)
      .setColor(color || "BLACK")
      .setDescription(description)
      .setURL(url)
      .setImage(image)
      .setThumbnail(thumbnail)
      return channel.send({ embed: EmbedCreator });
    } else if (!description) {
      var EmbedCreator = new MessageEmbed()
      .setAuthor(authorLabel, authorIcon)
      .setFooter(footerLabel, footerIcon)
      .setTitle(title)
      .setColor(color || "BLACK")
      .setURL(url)
      .setImage(image)
      .setThumbnail(thumbnail)
      return channel.send({ embed: EmbedCreator });
    } else if (!url) {
      var EmbedCreator = new MessageEmbed()
      .setAuthor(authorLabel, authorIcon)
      .setFooter(footerLabel, footerIcon)
      .setTitle(title)
      .setColor(color || "BLACK")
      .setDescription(description)
      .setImage(image)
      .setThumbnail(thumbnail)
      return channel.send({ embed: EmbedCreator });
    } else if (!image) {
      var EmbedCreator = new MessageEmbed()
      .setAuthor(authorLabel, authorIcon)
      .setFooter(footerLabel, footerIcon)
      .setTitle(title)
      .setColor(color || "BLACK")
      .setDescription(description)
      .setURL(url)
      .setThumbnail(thumbnail)
      return channel.send({ embed: EmbedCreator });
    } else if (!thumbnail) {
      var EmbedCreator = new MessageEmbed()
      .setAuthor(authorLabel, authorIcon)
      .setFooter(footerLabel, footerIcon)
      .setTitle(title)
      .setColor(color || "BLACK")
      .setDescription(description)
      .setImage(image)
      .setURL(url)
      return channel.send({ embed: EmbedCreator });
    } else if (title && authorLabel && authorIcon && footerLabel && footerIcon && description && color && url && image && thumbnail) {
      var EmbedCreator = new MessageEmbed()
      .setAuthor(authorLabel, authorIcon)
      .setFooter(footerLabel, footerIcon)
      .setTitle(title)
      .setColor(color)
      .setDescription(description)
      .setImage(image)
      .setURL(url)
      .setThumbnail(thumbnail)
      return channel.send({ embed: EmbedCreator });
    }
  }
}

module.exports = Message;